searchData={"items":[{"type":"module","title":"z_convert","doc":"Conversion functions for all kinds of data types. Changes to Rusty's version: added date conversion, undefined handling and more to_bool cases.","ref":"z_convert.html"},{"type":"function","title":"z_convert.clean_lower/1","doc":"Convert to lower case, strip surrounding whitespace.","ref":"z_convert.html#clean_lower/1"},{"type":"function","title":"z_convert.convert_json/1","doc":"Convert json from facebook favour to an easy to use format for zotonic templates.","ref":"z_convert.html#convert_json/1"},{"type":"function","title":"z_convert.ip_to_list/1","doc":null,"ref":"z_convert.html#ip_to_list/1"},{"type":"function","title":"z_convert.ip_to_long/1","doc":"Convert an IP address from a string, IPv4 tuple or IPv6 tuple to the big endian integer representation.","ref":"z_convert.html#ip_to_long/1"},{"type":"function","title":"z_convert.long_to_ip/1","doc":"Convert long int to IP address tuple. FIXME: ipv6","ref":"z_convert.html#long_to_ip/1"},{"type":"function","title":"z_convert.to_atom/1","doc":"Convert (almost) any value to an atom.","ref":"z_convert.html#to_atom/1"},{"type":"function","title":"z_convert.to_binary/1","doc":"Convert (almost) any value to an atom.","ref":"z_convert.html#to_binary/1"},{"type":"function","title":"z_convert.to_binary/2","doc":null,"ref":"z_convert.html#to_binary/2"},{"type":"function","title":"z_convert.to_bool/1","doc":"Quite loose conversion of values to boolean","ref":"z_convert.html#to_bool/1"},{"type":"function","title":"z_convert.to_bool_strict/1","doc":"Convert values to boolean values according to the Django rules","ref":"z_convert.html#to_bool_strict/1"},{"type":"function","title":"z_convert.to_date/1","doc":"Convert an input to a date. Input is expected to be YYYY-MM-DD or YYYY/MM/DD.","ref":"z_convert.html#to_date/1"},{"type":"function","title":"z_convert.to_datetime/1","doc":"Convert an input to a (universal) datetime, using to_date/1 and to_time/1. If the input is a string, it is expected to be in iso 8601 format, although it can also handle timestamps without time zones. The time component of the datatime is optional.","ref":"z_convert.html#to_datetime/1"},{"type":"function","title":"z_convert.to_flatlist/1","doc":"Flatten list and convert to string.","ref":"z_convert.html#to_flatlist/1"},{"type":"function","title":"z_convert.to_float/1","doc":"Convert (almost) any value to a float.","ref":"z_convert.html#to_float/1"},{"type":"function","title":"z_convert.to_integer/1","doc":"Convert (almost) any value to an integer.","ref":"z_convert.html#to_integer/1"},{"type":"function","title":"z_convert.to_isotime/1","doc":"Convert a datetime (in universal time) to an ISO time string.","ref":"z_convert.html#to_isotime/1"},{"type":"function","title":"z_convert.to_json/1","doc":"Convert an Erlang structure to a format that can be serialized by mochijson.","ref":"z_convert.html#to_json/1"},{"type":"function","title":"z_convert.to_list/1","doc":"Convert (almost) any value to a list.","ref":"z_convert.html#to_list/1"},{"type":"function","title":"z_convert.to_localtime/1","doc":"Convert a utc date time to local","ref":"z_convert.html#to_localtime/1"},{"type":"function","title":"z_convert.to_time/1","doc":"Convert an input to a time. Input is expected to be HH:MM:SS or HH.MM.SS.","ref":"z_convert.html#to_time/1"},{"type":"function","title":"z_convert.to_utc/1","doc":"Convert a local date time to utc","ref":"z_convert.html#to_utc/1"},{"type":"function","title":"z_convert.unicode_to_utf8/1","doc":null,"ref":"z_convert.html#unicode_to_utf8/1"},{"type":"module","title":"z_cover","doc":"Workarounds for various cover deficiencies.","ref":"z_cover.html"},{"type":"function","title":"z_cover.clause_lookup_table/1","doc":null,"ref":"z_cover.html#clause_lookup_table/1"},{"type":"function","title":"z_cover.clause_lookup_table/2","doc":null,"ref":"z_cover.html#clause_lookup_table/2"},{"type":"function","title":"z_cover.get_abstract_code/1","doc":null,"ref":"z_cover.html#get_abstract_code/1"},{"type":"function","title":"z_cover.get_beam/1","doc":null,"ref":"z_cover.html#get_beam/1"},{"type":"function","title":"z_cover.get_clauses/2","doc":null,"ref":"z_cover.html#get_clauses/2"},{"type":"module","title":"z_css","doc":"Utility functions for CSS processing. Also used for sanitizing HTML.","ref":"z_css.html"},{"type":"function","title":"z_css.parse/1","doc":"Parse a CSS binary or a token list. Return a parse tree of the css.","ref":"z_css.html#parse/1"},{"type":"function","title":"z_css.sanitize/1","doc":"Sanitize a css string, remove all external URI references and injectable content.","ref":"z_css.html#sanitize/1"},{"type":"function","title":"z_css.sanitize_style/1","doc":"Sanitize a css style tag, remove all external URI references and injectable content.","ref":"z_css.html#sanitize_style/1"},{"type":"function","title":"z_css.scan/1","doc":"Tokenize a CSS string to binary, returns a list of tokens.","ref":"z_css.html#scan/1"},{"type":"type","title":"z_css.charset/0","doc":null,"ref":"z_css.html#t:charset/0"},{"type":"type","title":"z_css.import/0","doc":null,"ref":"z_css.html#t:import/0"},{"type":"type","title":"z_css.line/0","doc":null,"ref":"z_css.html#t:line/0"},{"type":"type","title":"z_css.media/0","doc":null,"ref":"z_css.html#t:media/0"},{"type":"type","title":"z_css.medialist/0","doc":null,"ref":"z_css.html#t:medialist/0"},{"type":"type","title":"z_css.rules/0","doc":null,"ref":"z_css.html#t:rules/0"},{"type":"type","title":"z_css.stylesheet/0","doc":null,"ref":"z_css.html#t:stylesheet/0"},{"type":"type","title":"z_css.tk/0","doc":null,"ref":"z_css.html#t:tk/0"},{"type":"type","title":"z_css.token/0","doc":null,"ref":"z_css.html#t:token/0"},{"type":"type","title":"z_css.tokens/0","doc":null,"ref":"z_css.html#t:tokens/0"},{"type":"module","title":"z_css_lexer","doc":null,"ref":"z_css_lexer.html"},{"type":"function","title":"z_css_lexer.format_error/1","doc":null,"ref":"z_css_lexer.html#format_error/1"},{"type":"function","title":"z_css_lexer.string/1","doc":null,"ref":"z_css_lexer.html#string/1"},{"type":"function","title":"z_css_lexer.string/2","doc":null,"ref":"z_css_lexer.html#string/2"},{"type":"function","title":"z_css_lexer.token/2","doc":null,"ref":"z_css_lexer.html#token/2"},{"type":"function","title":"z_css_lexer.token/3","doc":null,"ref":"z_css_lexer.html#token/3"},{"type":"function","title":"z_css_lexer.tokens/2","doc":null,"ref":"z_css_lexer.html#tokens/2"},{"type":"function","title":"z_css_lexer.tokens/3","doc":null,"ref":"z_css_lexer.html#tokens/3"},{"type":"module","title":"z_css_parser","doc":null,"ref":"z_css_parser.html"},{"type":"function","title":"z_css_parser.format_error/1","doc":null,"ref":"z_css_parser.html#format_error/1"},{"type":"function","title":"z_css_parser.parse/1","doc":null,"ref":"z_css_parser.html#parse/1"},{"type":"function","title":"z_css_parser.parse_and_scan/1","doc":null,"ref":"z_css_parser.html#parse_and_scan/1"},{"type":"type","title":"z_css_parser.yecc_ret/0","doc":null,"ref":"z_css_parser.html#t:yecc_ret/0"},{"type":"module","title":"z_cssmin","doc":"Javascript minifier. Based on cssmin.c","ref":"z_cssmin.html"},{"type":"function","title":"z_cssmin.minify/1","doc":"Minify a binary containing CSS.","ref":"z_cssmin.html#minify/1"},{"type":"module","title":"z_dateformat","doc":null,"ref":"z_dateformat.html"},{"type":"function","title":"z_dateformat.format/1","doc":null,"ref":"z_dateformat.html#format/1"},{"type":"function","title":"z_dateformat.format/2","doc":null,"ref":"z_dateformat.html#format/2"},{"type":"function","title":"z_dateformat.format/3","doc":null,"ref":"z_dateformat.html#format/3"},{"type":"function","title":"z_dateformat.tz_name/3","doc":null,"ref":"z_dateformat.html#tz_name/3"},{"type":"type","title":"z_dateformat.date/0","doc":null,"ref":"z_dateformat.html#t:date/0"},{"type":"type","title":"z_dateformat.datetime/0","doc":null,"ref":"z_dateformat.html#t:datetime/0"},{"type":"type","title":"z_dateformat.tz/0","doc":null,"ref":"z_dateformat.html#t:tz/0"},{"type":"module","title":"z_email_dnsbl","doc":"Check an IP address against some DNSBL providers (rfc5782)","ref":"z_email_dnsbl.html"},{"type":"function","title":"z_email_dnsbl.dns_allowlist/0","doc":"Default list of DNSWL services","ref":"z_email_dnsbl.html#dns_allowlist/0"},{"type":"function","title":"z_email_dnsbl.dns_blocklist/0","doc":"Default list of DNSBL services","ref":"z_email_dnsbl.html#dns_blocklist/0"},{"type":"function","title":"z_email_dnsbl.is_blocked/1","doc":"Check if the IP address is on one of the default blocklists.","ref":"z_email_dnsbl.html#is_blocked/1"},{"type":"function","title":"z_email_dnsbl.is_blocked/2","doc":"Check if the IP address is on one of the given blocklists.","ref":"z_email_dnsbl.html#is_blocked/2"},{"type":"function","title":"z_email_dnsbl.is_blocked/3","doc":"Check if the IP address is on one of the given blocklists and not on one of the white lists. If an IP address is white listen then this routine always return true.","ref":"z_email_dnsbl.html#is_blocked/3"},{"type":"function","title":"z_email_dnsbl.status/1","doc":"Check the block- or allowlist status of an IP address. If it is blocked then the blocklists where the IP address is blocked are returned.","ref":"z_email_dnsbl.html#status/1"},{"type":"function","title":"z_email_dnsbl.status/2","doc":"Check the block- or allowlist status of an IP address with the given block lists. If it is blocked then the blocklists where the IP address is blocked are returned.","ref":"z_email_dnsbl.html#status/2"},{"type":"function","title":"z_email_dnsbl.status/3","doc":"Check the block- or whitelist status of an IP address with the given block- and whitelists. If it is blocked then the blocklists where the IP address is blocked are returned.","ref":"z_email_dnsbl.html#status/3"},{"type":"module","title":"z_email_utils","doc":"Useful routines for e-mail address handling.","ref":"z_email_utils.html"},{"type":"function","title":"z_email_utils.extract_emails/1","doc":"Extract e-mail addresses from a text. All e-mail addresses are lower cased, doubles are removed.","ref":"z_email_utils.html#extract_emails/1"},{"type":"function","title":"z_email_utils.is_email/1","doc":"Check if the argument is an e-mail address (without any extras like name, comments, etc.)","ref":"z_email_utils.html#is_email/1"},{"type":"module","title":"z_filelib","doc":"Extra file functions.","ref":"z_filelib.html"},{"type":"function","title":"z_filelib.ensure_dir/1","doc":"Ensure the directory of a file is present. This will still work if a soft-link in the path refers to a missing directory.","ref":"z_filelib.html#ensure_dir/1"},{"type":"function","title":"z_filelib.os_escape/1","doc":"Simple escape function for command line arguments","ref":"z_filelib.html#os_escape/1"},{"type":"function","title":"z_filelib.os_filename/1","doc":"Simple escape function for filenames as commandline arguments. foo/&quot;bar.jpg -&gt; &quot;foo/\\&quot;bar.jpg&quot;; on windows &quot;foo\\\\\\&quot;bar.jpg&quot; (both including quotes!)","ref":"z_filelib.html#os_filename/1"},{"type":"module","title":"z_html","doc":"Utility functions for html processing. Also used for property filtering (by m_rsc_update).","ref":"z_html.html"},{"type":"function","title":"z_html.abs_links/2","doc":"Make all links (href/src) in the html absolute to the base URL This takes a shortcut by checking all ' (src|href)=&quot;..&quot;'","ref":"z_html.html#abs_links/2"},{"type":"function","title":"z_html.br2nl/1","doc":"Translate any html br entities to newlines.","ref":"z_html.html#br2nl/1"},{"type":"function","title":"z_html.ensure_escaped_amp/1","doc":"Ensure that &amp; -characters are properly escaped inside a html string.","ref":"z_html.html#ensure_escaped_amp/1"},{"type":"function","title":"z_html.escape/1","doc":"Escape a string so that it is valid within HTML/ XML.","ref":"z_html.html#escape/1"},{"type":"function","title":"z_html.escape_check/1","doc":"Ensure that a string is escaped so that it is valid within HTML/ XML.","ref":"z_html.html#escape_check/1"},{"type":"function","title":"z_html.escape_html_comment/2","doc":"Escape smaller-than, greater-than (for in comments)","ref":"z_html.html#escape_html_comment/2"},{"type":"function","title":"z_html.escape_html_text/2","doc":"Escape smaller-than, greater-than, single and double quotes in texts (&amp; is already removed or escaped).","ref":"z_html.html#escape_html_text/2"},{"type":"function","title":"z_html.escape_link/1","doc":"Escape a text. Expands any urls to links with a nofollow attribute.","ref":"z_html.html#escape_link/1"},{"type":"function","title":"z_html.escape_props/1","doc":"Escape all properties used for an update statement. Only leaves the body property intact.","ref":"z_html.html#escape_props/1"},{"type":"function","title":"z_html.escape_props/2","doc":null,"ref":"z_html.html#escape_props/2"},{"type":"function","title":"z_html.escape_props_check/1","doc":"Checks if all properties are properly escaped","ref":"z_html.html#escape_props_check/1"},{"type":"function","title":"z_html.escape_props_check/2","doc":null,"ref":"z_html.html#escape_props_check/2"},{"type":"function","title":"z_html.flatten_attr/1","doc":"Flatten an attribute, attributes have been whitelisted and the values have been sanitized.","ref":"z_html.html#flatten_attr/1"},{"type":"function","title":"z_html.nl2br/1","doc":"Translate any newlines to html br entities.","ref":"z_html.html#nl2br/1"},{"type":"function","title":"z_html.noscript/1","doc":"Filter a url, remove any &quot;javascript:&quot; and &quot;data:&quot; (as data can be text/html).","ref":"z_html.html#noscript/1"},{"type":"function","title":"z_html.noscript/2","doc":"Filter an url, if strict then also remove &quot;data:&quot; (as data can be text/html).","ref":"z_html.html#noscript/2"},{"type":"function","title":"z_html.sanitize/1","doc":"Sanitize a (X)HTML string. Remove elements and attributes that might be harmful.","ref":"z_html.html#sanitize/1"},{"type":"function","title":"z_html.sanitize/2","doc":null,"ref":"z_html.html#sanitize/2"},{"type":"function","title":"z_html.sanitize/4","doc":"Sanitize a mochiwebparse tree. Remove harmful elements and attributes.","ref":"z_html.html#sanitize/4"},{"type":"function","title":"z_html.sanitize_attr_value/2","doc":null,"ref":"z_html.html#sanitize_attr_value/2"},{"type":"function","title":"z_html.sanitize_uri/1","doc":"Ensure that an uri is (quite) harmless by removing any script reference","ref":"z_html.html#sanitize_uri/1"},{"type":"function","title":"z_html.scrape_link_elements/1","doc":"Given a HTML list, scrape all &lt;link&gt; elements and return their attributes. Attribute names are lowercased.","ref":"z_html.html#scrape_link_elements/1"},{"type":"function","title":"z_html.strip/1","doc":"Strip all html elements from the text. Simple parsing is applied to find the elements. Does not escape the end result.","ref":"z_html.html#strip/1"},{"type":"function","title":"z_html.strip/2","doc":"Strip all html elements from the text. Simple parsing is applied to find the elements. Does not escape the end result. Limit the length of the result string to N characters.","ref":"z_html.html#strip/2"},{"type":"function","title":"z_html.truncate/2","doc":"Truncate a previously sanitized HTML string.","ref":"z_html.html#truncate/2"},{"type":"function","title":"z_html.truncate/3","doc":null,"ref":"z_html.html#truncate/3"},{"type":"function","title":"z_html.unescape/1","doc":"Unescape - reverses the effect of escape.","ref":"z_html.html#unescape/1"},{"type":"type","title":"z_html.maybe_binary/0","doc":null,"ref":"z_html.html#t:maybe_binary/0"},{"type":"type","title":"z_html.maybe_iodata/0","doc":null,"ref":"z_html.html#t:maybe_iodata/0"},{"type":"type","title":"z_html.maybe_text/0","doc":null,"ref":"z_html.html#t:maybe_text/0"},{"type":"type","title":"z_html.maybe_unsafe_text/0","doc":null,"ref":"z_html.html#t:maybe_unsafe_text/0"},{"type":"type","title":"z_html.sanitize_option/0","doc":null,"ref":"z_html.html#t:sanitize_option/0"},{"type":"type","title":"z_html.sanitize_options/0","doc":null,"ref":"z_html.html#t:sanitize_options/0"},{"type":"type","title":"z_html.text/0","doc":null,"ref":"z_html.html#t:text/0"},{"type":"type","title":"z_html.unsafe_text/0","doc":null,"ref":"z_html.html#t:unsafe_text/0"},{"type":"module","title":"z_html_charref","doc":"Converts HTML 4 charrefs and entities to codepoints.","ref":"z_html_charref.html"},{"type":"function","title":"z_html_charref.charref/1","doc":"Convert a decimal charref, hex charref, or html entity to a unicode codepoint, or return undefined on failure. The input should not include an ampersand or semicolon. charref(&quot;#38&quot;) = 38, charref(&quot;#x26&quot;) = 38, charref(&quot;amp&quot;) = 38.","ref":"z_html_charref.html#charref/1"},{"type":"module","title":"z_html_parse","doc":"Loosely tokenizes and generates parse trees for (X)HTML and XML. Adapted by Maas-Maarten Zeeman Extended for basic XML parsing by Marc Worrell","ref":"z_html_parse.html"},{"type":"function","title":"z_html_parse.escape/1","doc":"Escape a string such that it's safe for HTML (amp; lt; gt;).","ref":"z_html_parse.html#escape/1"},{"type":"function","title":"z_html_parse.escape_attr/1","doc":"Escape a string such that it's safe for HTML attrs (amp; lt; gt; quot;).","ref":"z_html_parse.html#escape_attr/1"},{"type":"function","title":"z_html_parse.parse/1","doc":"tokenize and then transform the token stream into a HTML tree.","ref":"z_html_parse.html#parse/1"},{"type":"function","title":"z_html_parse.parse/2","doc":null,"ref":"z_html_parse.html#parse/2"},{"type":"function","title":"z_html_parse.parse_to_map/1","doc":"Parse an HTML/XML document to a JSON compatible map. Attributes will be added as keys in an @attributes key. Elements will be mapped to keys with value lists. all keys are lowercased.","ref":"z_html_parse.html#parse_to_map/1"},{"type":"function","title":"z_html_parse.parse_to_map/2","doc":"Parse an HTML/XML document to a JSON compatible map. Attributes will be added as keys in an @attributes key. Elements will be mapped to keys with value lists. all keys are lowercased.","ref":"z_html_parse.html#parse_to_map/2"},{"type":"function","title":"z_html_parse.parse_tokens/1","doc":"Transform the output of tokens(Doc) into a HTML tree.","ref":"z_html_parse.html#parse_tokens/1"},{"type":"function","title":"z_html_parse.to_html/1","doc":"Convert a list of html_token() to a HTML document.","ref":"z_html_parse.html#to_html/1"},{"type":"function","title":"z_html_parse.to_html/2","doc":null,"ref":"z_html_parse.html#to_html/2"},{"type":"function","title":"z_html_parse.to_tokens/1","doc":"Convert a html_node() tree to a list of tokens.","ref":"z_html_parse.html#to_tokens/1"},{"type":"function","title":"z_html_parse.to_tokens/2","doc":null,"ref":"z_html_parse.html#to_tokens/2"},{"type":"function","title":"z_html_parse.tokens/1","doc":"Transform the input UTF-8 HTML into a token stream.","ref":"z_html_parse.html#tokens/1"},{"type":"function","title":"z_html_parse.tokens/2","doc":null,"ref":"z_html_parse.html#tokens/2"},{"type":"type","title":"z_html_parse.end_tag/0","doc":null,"ref":"z_html_parse.html#t:end_tag/0"},{"type":"type","title":"z_html_parse.html_attr/0","doc":null,"ref":"z_html_parse.html#t:html_attr/0"},{"type":"type","title":"z_html_parse.html_attr_name/0","doc":null,"ref":"z_html_parse.html#t:html_attr_name/0"},{"type":"type","title":"z_html_parse.html_attr_value/0","doc":null,"ref":"z_html_parse.html#t:html_attr_value/0"},{"type":"type","title":"z_html_parse.html_comment/0","doc":null,"ref":"z_html_parse.html#t:html_comment/0"},{"type":"type","title":"z_html_parse.html_data/0","doc":null,"ref":"z_html_parse.html#t:html_data/0"},{"type":"type","title":"z_html_parse.html_doctype/0","doc":null,"ref":"z_html_parse.html#t:html_doctype/0"},{"type":"type","title":"z_html_parse.html_element/0","doc":null,"ref":"z_html_parse.html#t:html_element/0"},{"type":"type","title":"z_html_parse.html_node/0","doc":null,"ref":"z_html_parse.html#t:html_node/0"},{"type":"type","title":"z_html_parse.html_nop/0","doc":"Special node used by sanitizer for unwanted elements","ref":"z_html_parse.html#t:html_nop/0"},{"type":"type","title":"z_html_parse.html_tag/0","doc":null,"ref":"z_html_parse.html#t:html_tag/0"},{"type":"type","title":"z_html_parse.html_token/0","doc":null,"ref":"z_html_parse.html#t:html_token/0"},{"type":"type","title":"z_html_parse.html_tree/0","doc":null,"ref":"z_html_parse.html#t:html_tree/0"},{"type":"type","title":"z_html_parse.inline_html/0","doc":null,"ref":"z_html_parse.html#t:inline_html/0"},{"type":"type","title":"z_html_parse.options/0","doc":null,"ref":"z_html_parse.html#t:options/0"},{"type":"type","title":"z_html_parse.pi_tag/0","doc":null,"ref":"z_html_parse.html#t:pi_tag/0"},{"type":"type","title":"z_html_parse.start_tag/0","doc":null,"ref":"z_html_parse.html#t:start_tag/0"},{"type":"module","title":"z_ip_address","doc":"Misc utility URL functions for zotonic","ref":"z_ip_address.html"},{"type":"function","title":"z_ip_address.ip_match/2","doc":"Check if an IP address matches a list of addresses and masks like &quot;127.0.0.0/8,10.0.0.0/8,fe80::/10&quot;","ref":"z_ip_address.html#ip_match/2"},{"type":"function","title":"z_ip_address.is_local/1","doc":"An IP address is local if it matches &quot;127.0.0.0/8,10.0.0.0/8,192.168.0.0/16,172.16.0.0/12,169.254.0.0/16,::1,fd00::/8,fe80::/10,100.64.0.0/10&quot;","ref":"z_ip_address.html#is_local/1"},{"type":"function","title":"z_ip_address.is_local_name/1","doc":"Check if the host name resolves to a local IP address.","ref":"z_ip_address.html#is_local_name/1"},{"type":"module","title":"z_jsmin","doc":"Javascript minifier. Based on jsmin.c","ref":"z_jsmin.html"},{"type":"function","title":"z_jsmin.minify/1","doc":"Minify a binary containing JavaScript.","ref":"z_jsmin.html#minify/1"},{"type":"module","title":"z_mochinum","doc":"Useful numeric algorithms for floats that cover some deficiencies in the math module. More interesting is digits/1, which implements the algorithm from: http://www.cs.indiana.edu/~burger/fp/index.html See also &quot;Printing Floating-Point Numbers Quickly and Accurately&quot; in Proceedings of the SIGPLAN '96 Conference on Programming Language Design and Implementation.","ref":"z_mochinum.html"},{"type":"function","title":"z_mochinum.digits/1","doc":"Returns a string that accurately represents the given integer or float using a conservative amount of digits. Great for generating human-readable output, or compact ASCII serializations for floats.","ref":"z_mochinum.html#digits/1"},{"type":"function","title":"z_mochinum.frexp/1","doc":"Return the fractional and exponent part of an IEEE 754 double, equivalent to the libc function of the same name. F = Frac * pow(2, Exp).","ref":"z_mochinum.html#frexp/1"},{"type":"function","title":"z_mochinum.int_ceil/1","doc":"Return the ceiling of F as an integer. The ceiling is defined as F when F == trunc(F); trunc(F) when F &lt; 0; trunc(F) + 1 when F &gt; 0.","ref":"z_mochinum.html#int_ceil/1"},{"type":"function","title":"z_mochinum.int_pow/2","doc":"Moderately efficient way to exponentiate integers. int_pow(10, 2) = 100.","ref":"z_mochinum.html#int_pow/2"},{"type":"module","title":"z_string","doc":"String related functions","ref":"z_string.html"},{"type":"function","title":"z_string.concat/2","doc":"Concatenate two strings (list or binary). Return type matching the first part.","ref":"z_string.html#concat/2"},{"type":"function","title":"z_string.contains/2","doc":"Return true if What is found in the string","ref":"z_string.html#contains/2"},{"type":"function","title":"z_string.distance/2","doc":"Calculate the Levensthein distance between two strings. Adapted from https://rosettacode.org/wiki/Levenshtein_distance#Erlang to use binary utf8 strings and maps. The smaller the returned integer the closer the strings are. Distance 0 means the two strings are equal.","ref":"z_string.html#distance/2"},{"type":"function","title":"z_string.ends_with/2","doc":"Return true if Word ends with End","ref":"z_string.html#ends_with/2"},{"type":"function","title":"z_string.escape_ical/1","doc":"Escape special characters for ical RFC2445 elements","ref":"z_string.html#escape_ical/1"},{"type":"function","title":"z_string.first_char/1","doc":"Return the first character of a string.","ref":"z_string.html#first_char/1"},{"type":"function","title":"z_string.is_string/1","doc":"Check if the variable is a one dimensional list of bytes, or a valid utf-8 binary.","ref":"z_string.html#is_string/1"},{"type":"function","title":"z_string.is_whitespace/1","doc":"Is the character an ASCII or Unicode whitespace character? See @link https://en.wikipedia.org/wiki/Whitespace_character","ref":"z_string.html#is_whitespace/1"},{"type":"function","title":"z_string.last_char/1","doc":"Return the last character of a string","ref":"z_string.html#last_char/1"},{"type":"function","title":"z_string.len/1","doc":null,"ref":"z_string.html#len/1"},{"type":"function","title":"z_string.line/1","doc":"Make sure that the string is on one line only, replace control characters with spaces","ref":"z_string.html#line/1"},{"type":"function","title":"z_string.normalize/1","doc":"Transliterate an unicode string to an ascii string with lowercase characters. Tries to transliterate some characters to a..z","ref":"z_string.html#normalize/1"},{"type":"function","title":"z_string.nospaces/1","doc":"Remove all spaces and control characters from a string.","ref":"z_string.html#nospaces/1"},{"type":"function","title":"z_string.replace/3","doc":"Replace a string inside another string Copyright 2008 Rusty Klophaus (Nitrogen, MIT License)","ref":"z_string.html#replace/3"},{"type":"function","title":"z_string.sanitize_utf8/1","doc":"Sanitize an utf-8 string, remove all non-utf-8 characters.","ref":"z_string.html#sanitize_utf8/1"},{"type":"function","title":"z_string.split/2","doc":"Split a string, see http://www.erlang.org/pipermail/erlang-questions/2008-October/038896.html","ref":"z_string.html#split/2"},{"type":"function","title":"z_string.split_lines/1","doc":"Split the binary into lines. Line separators can be \\r, \\n or \\r\\n.","ref":"z_string.html#split_lines/1"},{"type":"function","title":"z_string.starts_with/2","doc":"Return true if Start is a prefix of Word","ref":"z_string.html#starts_with/2"},{"type":"function","title":"z_string.to_lower/1","doc":"Return a lowercase string for the input","ref":"z_string.html#to_lower/1"},{"type":"function","title":"z_string.to_name/1","doc":"Map a string to a value that can be used as a name or slug. Maps all characters to lowercase and remove non digalpha chars","ref":"z_string.html#to_name/1"},{"type":"function","title":"z_string.to_rootname/1","doc":"Filter a filename so that we obtain a basename that is safe to use.","ref":"z_string.html#to_rootname/1"},{"type":"function","title":"z_string.to_slug/1","doc":"Map a string to a slug that can be used in the uri of a page. Same as a name, but then with dashes instead of underscores.","ref":"z_string.html#to_slug/1"},{"type":"function","title":"z_string.to_upper/1","doc":"Return a uppercase string for the input","ref":"z_string.html#to_upper/1"},{"type":"function","title":"z_string.trim/1","doc":"Remove whitespace at the start and end of the string","ref":"z_string.html#trim/1"},{"type":"function","title":"z_string.trim/2","doc":"Remove all occurrences of a character at the start and end of a string.","ref":"z_string.html#trim/2"},{"type":"function","title":"z_string.trim_left/1","doc":"Remove whitespace at the start the string","ref":"z_string.html#trim_left/1"},{"type":"function","title":"z_string.trim_left/2","doc":"Remove all occurrences of a char at the start of a string","ref":"z_string.html#trim_left/2"},{"type":"function","title":"z_string.trim_left_func/2","doc":null,"ref":"z_string.html#trim_left_func/2"},{"type":"function","title":"z_string.trim_right/1","doc":"Remove whitespace at the end of the string","ref":"z_string.html#trim_right/1"},{"type":"function","title":"z_string.trim_right/2","doc":"Remove all occurrences of a char at the end of the string","ref":"z_string.html#trim_right/2"},{"type":"function","title":"z_string.truncate/2","doc":"Truncate a string. Append the '...' character at the place of break off.","ref":"z_string.html#truncate/2"},{"type":"function","title":"z_string.truncate/3","doc":null,"ref":"z_string.html#truncate/3"},{"type":"function","title":"z_string.truncatechars/2","doc":"Truncate a string, count all characters. No special handling of entities and tags.","ref":"z_string.html#truncatechars/2"},{"type":"function","title":"z_string.truncatechars/3","doc":null,"ref":"z_string.html#truncatechars/3"},{"type":"function","title":"z_string.truncatewords/2","doc":"Truncate a string, count all words. No special handling of entities and tags.","ref":"z_string.html#truncatewords/2"},{"type":"function","title":"z_string.truncatewords/3","doc":null,"ref":"z_string.html#truncatewords/3"},{"type":"function","title":"z_string.unquote/1","doc":"Remove the first and last char if they are double quotes.","ref":"z_string.html#unquote/1"},{"type":"function","title":"z_string.unquote/2","doc":null,"ref":"z_string.html#unquote/2"},{"type":"module","title":"z_svg","doc":"Utility functions for svg processing.","ref":"z_svg.html"},{"type":"function","title":"z_svg.sanitize/1","doc":"Sanitize a binary containing a SVG","ref":"z_svg.html#sanitize/1"},{"type":"function","title":"z_svg.sanitize_element/1","doc":"Sanitize an element from the SVG parse tree. Also called from z_html.erl","ref":"z_svg.html#sanitize_element/1"},{"type":"type","title":"z_svg.svg_element/0","doc":null,"ref":"z_svg.html#t:svg_element/0"},{"type":"module","title":"z_tempfile","doc":"Simple temporary file handling, deletes the file when the calling process stops or crashes.","ref":"z_tempfile.html"},{"type":"function","title":"z_tempfile.cleanup/0","doc":"Delete all tempfiles not modified in the last day.","ref":"z_tempfile.html#cleanup/0"},{"type":"function","title":"z_tempfile.is_tempfile/1","doc":"Check if the file is a temporary filename.","ref":"z_tempfile.html#is_tempfile/1"},{"type":"function","title":"z_tempfile.monitored_attach/1","doc":"Add a process to the tempfile monitor. The tempfile is deleted after all attached processes stopped or are detached.","ref":"z_tempfile.html#monitored_attach/1"},{"type":"function","title":"z_tempfile.monitored_detach/1","doc":"Remove a process from the tempfile monitor. The tempfile is deleted after all attached processes stopped or are detached.","ref":"z_tempfile.html#monitored_detach/1"},{"type":"function","title":"z_tempfile.monitored_new/0","doc":"Like new/0 but also return the Pid of the monitoring process.","ref":"z_tempfile.html#monitored_new/0"},{"type":"function","title":"z_tempfile.monitored_new/1","doc":"Like new/1 but also return the Pid of the monitoring process.","ref":"z_tempfile.html#monitored_new/1"},{"type":"function","title":"z_tempfile.new/0","doc":"Return a new unique filename, start a monitoring process to clean it up after use. The file must be created and written within 10 seconds, or it will be deleted.","ref":"z_tempfile.html#new/0"},{"type":"function","title":"z_tempfile.new/1","doc":"Return a new unique filename, start a monitoring process to clean it up after use. The file must be created and written within 10 seconds, or it will be deleted.","ref":"z_tempfile.html#new/1"},{"type":"function","title":"z_tempfile.tempfile/0","doc":"return a unique temporary filename located in the TMP directory.","ref":"z_tempfile.html#tempfile/0"},{"type":"function","title":"z_tempfile.tempfile/1","doc":"return a unique temporary filename with the given extension.","ref":"z_tempfile.html#tempfile/1"},{"type":"function","title":"z_tempfile.temppath/0","doc":"Returns the path where to store temporary files.","ref":"z_tempfile.html#temppath/0"},{"type":"module","title":"z_ubf","doc":null,"ref":"z_ubf.html"},{"type":"function","title":"z_ubf.deabstract/1","doc":null,"ref":"z_ubf.html#deabstract/1"},{"type":"function","title":"z_ubf.decode/1","doc":null,"ref":"z_ubf.html#decode/1"},{"type":"function","title":"z_ubf.decode/2","doc":null,"ref":"z_ubf.html#decode/2"},{"type":"function","title":"z_ubf.decode_init/0","doc":null,"ref":"z_ubf.html#decode_init/0"},{"type":"function","title":"z_ubf.decode_init/1","doc":null,"ref":"z_ubf.html#decode_init/1"},{"type":"function","title":"z_ubf.encode/1","doc":null,"ref":"z_ubf.html#encode/1"},{"type":"function","title":"z_ubf.encode/2","doc":null,"ref":"z_ubf.html#encode/2"},{"type":"function","title":"z_ubf.encode_print/1","doc":null,"ref":"z_ubf.html#encode_print/1"},{"type":"module","title":"z_url","doc":"Misc utility URL functions for zotonic","ref":"z_url.html"},{"type":"function","title":"z_url.abs_link/2","doc":"Given a relative URL and a base URL, calculate the absolute URL.","ref":"z_url.html#abs_link/2"},{"type":"function","title":"z_url.decode_data_url/1","doc":"Decode a &quot;data:&quot; url to its parts. Crashes if the url doesn't have a &quot;data:&quot; protocol.","ref":"z_url.html#decode_data_url/1"},{"type":"function","title":"z_url.hex_decode/1","doc":null,"ref":"z_url.html#hex_decode/1"},{"type":"function","title":"z_url.hex_encode/1","doc":null,"ref":"z_url.html#hex_encode/1"},{"type":"function","title":"z_url.hex_encode_lc/1","doc":null,"ref":"z_url.html#hex_encode_lc/1"},{"type":"function","title":"z_url.location/1","doc":"Find the definitive location of an url, removing url shorteners in the process. Identify as Curl to prevent url shorteners returning HTML pages.","ref":"z_url.html#location/1"},{"type":"function","title":"z_url.percent_encode/1","doc":"Percent encoding/decoding as defined by RFC 3986 (http://tools.ietf.org/html/rfc3986).","ref":"z_url.html#percent_encode/1"},{"type":"function","title":"z_url.percent_encode/2","doc":null,"ref":"z_url.html#percent_encode/2"},{"type":"function","title":"z_url.remove_protocol/1","doc":"Naive function to remove the protocol from an Url","ref":"z_url.html#remove_protocol/1"},{"type":"function","title":"z_url.split_base_host/1","doc":null,"ref":"z_url.html#split_base_host/1"},{"type":"function","title":"z_url.url_decode/1","doc":null,"ref":"z_url.html#url_decode/1"},{"type":"function","title":"z_url.url_encode/1","doc":null,"ref":"z_url.html#url_encode/1"},{"type":"function","title":"z_url.url_path_encode/1","doc":null,"ref":"z_url.html#url_path_encode/1"},{"type":"function","title":"z_url.url_reserved_char/1","doc":null,"ref":"z_url.html#url_reserved_char/1"},{"type":"function","title":"z_url.url_unreserved_char/1","doc":null,"ref":"z_url.html#url_unreserved_char/1"},{"type":"function","title":"z_url.url_valid_char/1","doc":null,"ref":"z_url.html#url_valid_char/1"},{"type":"module","title":"z_url_fetch","doc":"Fetch (part of) the data of an Url, including its headers.","ref":"z_url_fetch.html"},{"type":"function","title":"z_url_fetch.ensure_profiles/0","doc":null,"ref":"z_url_fetch.html#ensure_profiles/0"},{"type":"function","title":"z_url_fetch.fetch/2","doc":"Fetch the data and headers from an url","ref":"z_url_fetch.html#fetch/2"},{"type":"function","title":"z_url_fetch.fetch/4","doc":"Fetch the data and headers from an url","ref":"z_url_fetch.html#fetch/4"},{"type":"function","title":"z_url_fetch.fetch_partial/1","doc":"Fetch the first 64 kilobytes of data and headers from an url","ref":"z_url_fetch.html#fetch_partial/1"},{"type":"function","title":"z_url_fetch.fetch_partial/2","doc":"Fetch the first N bytes of data and headers from an url, optionally save to the file device","ref":"z_url_fetch.html#fetch_partial/2"},{"type":"function","title":"z_url_fetch.fetch_partial/4","doc":"Fetch the first N bytes of data and headers from an url, optionally save to the file device","ref":"z_url_fetch.html#fetch_partial/4"},{"type":"function","title":"z_url_fetch.periodic_cleanup/0","doc":null,"ref":"z_url_fetch.html#periodic_cleanup/0"},{"type":"function","title":"z_url_fetch.profile/1","doc":null,"ref":"z_url_fetch.html#profile/1"},{"type":"type","title":"z_url_fetch.fetch_result/0","doc":null,"ref":"z_url_fetch.html#t:fetch_result/0"},{"type":"type","title":"z_url_fetch.option/0","doc":null,"ref":"z_url_fetch.html#t:option/0"},{"type":"type","title":"z_url_fetch.options/0","doc":null,"ref":"z_url_fetch.html#t:options/0"},{"type":"module","title":"z_url_metadata","doc":"Discover metadata about an url.","ref":"z_url_metadata.html"},{"type":"function","title":"z_url_metadata.fetch/1","doc":"Fetch metadata information for the URL","ref":"z_url_metadata.html#fetch/1"},{"type":"function","title":"z_url_metadata.fetch/2","doc":null,"ref":"z_url_metadata.html#fetch/2"},{"type":"function","title":"z_url_metadata.filename/2","doc":null,"ref":"z_url_metadata.html#filename/2"},{"type":"function","title":"z_url_metadata.header/2","doc":null,"ref":"z_url_metadata.html#header/2"},{"type":"function","title":"z_url_metadata.html_meta/1","doc":null,"ref":"z_url_metadata.html#html_meta/1"},{"type":"function","title":"z_url_metadata.p/2","doc":"Fetch properties of the fetched metadata","ref":"z_url_metadata.html#p/2"},{"type":"type","title":"z_url_metadata.metadata/0","doc":null,"ref":"z_url_metadata.html#t:metadata/0"},{"type":"extras","title":"README","doc":"![Test](https://github.com/zotonic/z_stdlib/workflows/Test/badge.svg)\n[![Hex.pm Version](https://img.shields.io/hexpm/v/zotonic_stdlib.svg)](https://hex.pm/packages/zotonic_stdlib)\n[![Hex.pm Downloads](https://img.shields.io/hexpm/dt/zotonic_stdlib.svg)](https://hex.pm/packages/zotonic_stdlib)\n\nzotonic_stdlib\n==============\n\nZotonic standard library - a library with hopefully useful functions\n\nExtracted from Zotonic, the Erlang CMS http://zotonic.com/\n\n\nInstallation\n------------\n\nDue to historical reasons the library is called `z_stdlib`.\nIt should be checked out as `zotonic_stdlib`:\n\n    git clone https://github.com/zotonic/z_stdlib.git zotonic_stdlib\n\nThe library is also on Hex https://hex.pm/packages/zotonic_stdlib\n\nIn your rebar.config file, use Hex (for rebar3):\n\n    {deps, [\n        zotonic_stdlib\n    ]}.\n\nOr, directly git (rebar2):\n\n    {deps, [\n        {zotonic_stdlib, \".*\", {git, \"https://github.com/zotonic/z_stdlib.git\", \"master\"}}\n    ]}.\n\n\nModules\n-------\n\nThe following modules are provided:\n\n\n#","ref":"readme.html"},{"type":"extras","title":"z_convert - README","doc":"Conversion routines for:\n\n * all common data types (binary, boolean, integer, etc.).\n * dates: to_utc, to_local, iso8601 parsing\n * json, convert to simple json constructs\n * IP address conversions\n\n\n#","ref":"readme.html#z_convert"},{"type":"extras","title":"z_css - README","doc":"Strict CSS parser and sanitizer.\n\n#","ref":"readme.html#z_css"},{"type":"extras","title":"z_cssmin - README","doc":"CSS minifier\n\n#","ref":"readme.html#z_cssmin"},{"type":"extras","title":"z_dateformat - README","doc":"Routines for formatting dates.\nExample:\n\n    z_dateformat:format({{2008,12,10},{15,30,0}}, \"Y-m-d H:i:s\", [ {tz, \"GMT\"} ]).\n\n\n#","ref":"readme.html#z_dateformat"},{"type":"extras","title":"z_email_dnsbl - README","doc":"Check IP addresses for their presence on DNS block- or allowlists.\n\n\n#","ref":"readme.html#z_email_dnsbl"},{"type":"extras","title":"z_email_utils - README","doc":"Test if an email address is syntactically valid. Extract email address from a text.\n\n\n#","ref":"readme.html#z_email_utils"},{"type":"extras","title":"z_filelib - README","doc":"Convenience function to make nested directories.\n\n\n#","ref":"readme.html#z_filelib"},{"type":"extras","title":"z_html - README","doc":"HTML routines like escape, unescape, sanitize, etc.\n\n\n#","ref":"readme.html#z_html"},{"type":"extras","title":"z_ip_address - README","doc":"Match an IP address against lists, check if an IP address is a non routable LAN address.\n\n\n#","ref":"readme.html#z_ip_address"},{"type":"extras","title":"z_jsmin - README","doc":"JavaScript minimizer, removes spaces, comments and newlines.\n\n\n#","ref":"readme.html#z_jsmin"},{"type":"extras","title":"z_string - README","doc":"String routines. To uppercase, lowercase, truncate, trim, utf8 checks, and more.\n\n\n#","ref":"readme.html#z_string"},{"type":"extras","title":"z_svg - README","doc":"SVG sanitizer.\n\n\n#","ref":"readme.html#z_svg"},{"type":"extras","title":"z_tempfile - README","doc":"Temporary file routines. Make tempfiles, including watch dog process to clean up the file.\n\n\n#","ref":"readme.html#z_tempfile"},{"type":"extras","title":"z_ubf - README","doc":"UBF-A encoding and decoding routines. Safe for atoms and maximum memory size.\n\n\n#","ref":"readme.html#z_ubf"},{"type":"extras","title":"z_url - README","doc":"URL encode, decode and more.\n\n\n#","ref":"readme.html#z_url"},{"type":"extras","title":"z_url_fetch - README","doc":"Fetch the first N bytes of a URL. Protection against too large return body.\n\n\n#","ref":"readme.html#z_url_fetch"},{"type":"extras","title":"z_url_metadata - README","doc":"Fetch URL, extract metadata like mime type, title, description, images etc.\n\n\nTests\n-----\n\nTo run the test set:\n\n    make test\n\nAll tests should pass.","ref":"readme.html#z_url_metadata"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}